!----------------------------------------------------------------------
!     Copyright (c) 2002 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!ɽ  at_module ƥȥץ
!      1 
!
!  2002/11/19  ݹ
!      2007/10/25  ݹ  顼åɲ
!
program at_test_boundaries1d

  use dc_message, only : MessageNotify
  use at_module
  implicit none

  integer, parameter :: im=8, km=8
  real(8), parameter :: xmin=-1.0D0, xmax=1.0D0
  real(8), parameter :: amin=2.0D0, amax=-1.0D0

  real(8), dimension(0:im) :: g_a
  real(8), dimension(0:im) :: g_dadx
  real(8), dimension(0:km) :: t_a
  real(8), dimension(2)    :: values=(/amin,amax/)

  real(8), parameter    :: eps=1.0D-10                 ! Ƹ

  call at_initial(im,km,xmin,xmax)

  g_a = sin(g_X)
  t_a = t_g(g_a)

!----- at_BoundariesGrid_DD ------
  write(6,*) 'Test of at_BoundariesGrid_DD...'
  call at_BoundariesGrid_DD(t_a,values)
  g_a = g_t(t_a)
  if ( max(abs(g_a(0)-amin),abs(g_a(im)-amax)) > eps )then
     call MessageNotify('E','Test of at_BoundariesGrid_DD', &
          'B.C. adoption error too large.')
  endif
  call MessageNotify('M','Test of at_BoundariesGrid_DD', &
       'Test of at_BoundariesGrid_DD suceeded!')
  
!----- at_BoundariesGrid_DN ------
  write(6,*) 'Test of at_BoundariesGrid_DN...'
  call at_BoundariesGrid_DN(t_a,values)
  g_a = g_t(t_a)
  g_dadx = g_t(t_dx_t(t_g(g_a)))
  if ( max(abs(g_a(0)-amin),abs(g_dadx(im)-amax)) > eps )then
     call MessageNotify('E','Test of at_BoundariesGrid_DN', &
          'B.C. adoption error too large.')
  endif
  call MessageNotify('M','Test of at_BoundariesGrid_DN', &
       'Test of at_BoundariesGrid_DN suceeded!')

!----- at_BoundariesGrid_ND ------
  write(6,*) 'Test of at_BoundariesGrid_ND...'
  call at_BoundariesGrid_ND(t_a,values)
  g_a = g_t(t_a)
  g_dadx = g_t(t_dx_t(t_g(g_a)))
  if ( max(abs(g_dadx(0)-amin),abs(g_a(im)-amax)) > eps )then
     call MessageNotify('E','Test of at_BoundariesGrid_ND', &
          'B.C. adoption error too large.')
  endif
  call MessageNotify('M','Test of at_BoundariesGrid_ND', &
       'Test of at_BoundariesGrid_ND suceeded!')

!----- at_BoundariesGrid_NN ------
  write(6,*) 'Test of at_BoundariesGrid_NN...'
  call at_BoundariesGrid_NN(t_a,values)
  g_a = g_t(t_a)
  g_dadx = g_t(t_dx_t(t_g(g_a)))
  if ( max(abs(g_dadx(0)-amin),abs(g_dadx(im)-amax)) > eps )then
     call MessageNotify('E','Test of at_BoundariesGrid_NN', &
          'B.C. adoption error too large.')
  endif
  call MessageNotify('M','Test of at_BoundariesGrid_NN', &
       'Test of at_BoundariesGrid_NN suceeded!')

!----- at_BoundariesTau_DD ------
  write(6,*) 'Test of at_BoundariesTau_DD...'
  call at_BoundariesTau_DD(t_a,values)
  g_a = g_t(t_a)
  if ( max(abs(g_a(0)-amin),abs(g_a(im)-amax)) > eps )then
     call MessageNotify('E','Test of at_BoundariesTau_DD', &
          'B.C. adoption error too large.')
  endif
  call MessageNotify('M','Test of at_BoundariesTau_DD', &
       'Test of at_BoundariesTau_DD suceeded!')
  
!----- at_BoundariesTau_DN ------
  write(6,*) 'Test of at_BoundariesTau_DN...'
  call at_BoundariesTau_DN(t_a,values)
  g_a = g_t(t_a)
  g_dadx = g_t(t_dx_t(t_g(g_a)))
  if ( max(abs(g_a(0)-amin),abs(g_dadx(im)-amax)) > eps )then
     call MessageNotify('E','Test of at_BoundariesTau_DN', &
          'B.C. adoption error too large.')
  endif
  call MessageNotify('M','Test of at_BoundariesTau_DN', &
       'Test of at_BoundariesTau_DN suceeded!')

!----- at_BoundariesTau_ND ------
  write(6,*) 'Test of at_BoundariesTau_ND...'
  call at_BoundariesTau_ND(t_a,values)
  g_a = g_t(t_a)
  g_dadx = g_t(t_dx_t(t_g(g_a)))
  if ( max(abs(g_dadx(0)-amin),abs(g_a(im)-amax)) > eps )then
     call MessageNotify('E','Test of at_BoundariesTau_ND', &
          'B.C. adoption error too large.')
  endif
  call MessageNotify('M','Test of at_BoundariesTau_ND', &
       'Test of at_BoundariesTau_ND suceeded!')

!----- at_BoundariesTau_NN ------
  write(6,*) 'Test of at_BoundariesTau_NN...'
  call at_BoundariesTau_NN(t_a,values)
  g_a = g_t(t_a)
  g_dadx = g_t(t_dx_t(t_g(g_a)))
  if ( max(abs(g_dadx(0)-amin),abs(g_dadx(im)-amax)) > eps )then
     call MessageNotify('E','Test of at_BoundariesTau_NN', &
          'B.C. adoption error too large.')
  endif
  call MessageNotify('M','Test of at_BoundariesTau_NN', &
       'Test of at_BoundariesTau_NN suceeded!')

end program at_test_boundaries1d
