!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!ɽ  wq_module ƥȥץ
!
!      ؿΥƥ
!      xyz_GradLon_wq, xyz_GradLat_wq, wq_Div_xyz_xyz_xyz
!  
!  2008/04/03  ݹ
!      2008/07/05  ʿ  ѹ
!
program wq_test_derivative2

  use dc_message, only : MessageNotify
  use wq_module
  implicit none

  integer,parameter  :: im=32, jm=16, km=8   ! ʻ(, , ư)
  integer,parameter  :: nm=10, lm=15         ! ȿ(ʿ, ư)
  real(8),parameter  :: ra=0.5               ! Ⱦ

  real(8), dimension(0:im-1,1:jm,km)     :: xyr_VLon
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_VLat
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_VRad
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_GradLon
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_GradLat
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_Div
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_Data
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_Psi

  real(8), parameter :: eps = 1D-10
  integer, parameter :: n=2

  integer :: i,j,k

  call MessageNotify('M','wq_test_derivative2', &
       'wq_module derivative function test #2')

  call wq_Initial(im,jm,km,nm,lm,ra)

  write( 6,* ) 'Test for xyr_GradLon_wq, xyr_GradLat_wq, wq_Div_xyr_xyr_xyr.'
  write( 6,* ) 'Output is displayed if computational error is larger than',eps

! -----------------  1 --------------------
  xyr_VRad = 0.0D0
  xyr_Psi = xyr_Rad**(n+1) * cos(xyr_Lat)*sin(xyr_Lon)   ! r**3 P_1^1

  xyr_GradLon =  xyr_Rad**n * cos(xyr_Lon)
  xyr_GradLat = -xyr_Rad**n * sin(xyr_Lat)*sin(xyr_Lon)

  xyr_Div = - 2* xyr_Psi/xyr_Rad**2

  write(6,*)
  write(6,*)'P11 field'
  call checkresult

! -----------------  2 --------------------
  xyr_VRad = 0.0D0
  xyr_Psi = xyr_Rad**n * cos(xyr_Lat)*sin(xyr_Lat) * sin(xyr_Lon) ! P_2^1

  xyr_GradLon =  xyr_Rad**(n-1)*sin(xyr_Lat)*cos(xyr_Lon)
  xyr_GradLat =  xyr_Rad**(n-1)*cos(2*xyr_Lat)*sin(xyr_Lon)

  xyr_Div = - 6* xyr_Psi/xyr_Rad**2

  write(6,*)
  write(6,*)'P21 field'
  call checkresult

  call MessageNotify('M','wq_test_derivative2', &
       'wq_module derivative function test #2 succeeded!')

  stop
contains

  subroutine checkresult

    xyr_VLon =  xyr_GradLon_wq(wq_xyr(xyr_Psi))
    write(6,*)'Checking GradLon (1/r cos(Lat) d/dLon)'
    do k=1,km
       do j=1,jm
          do i=0,im-1
             if ( abs(xyr_VLon(i,j,k)-xyr_GradLon(i,j,k)) > eps ) then
                write(6,*) i,j,k, xyr_VLon(i,j,k), xyr_GradLon(i,j,k)
                call MessageNotify('E','wq_test_derivative2', &
                     'Derivative error too large.')
             endif
          end do
       end do
    end do

    xyr_VLat =  xyr_GradLat_wq(wq_xyr(xyr_Psi))
    write(6,*)'Checking GradLat (1/r dLat)'
    do k=1,km
       do j=1,jm
          do i=0,im-1
             if ( abs(xyr_VLat(i,j,k)-xyr_GradLat(i,j,k)) > eps ) then
                write(6,*) i,j,k, xyr_VLat(i,j,k), xyr_GradLat(i,j,k)
                call MessageNotify('E','wq_test_derivative2', &
                     'Derivative error too large.')
             endif
          end do
       end do
    end do

    xyr_Data = xyr_wr(wr_Div_xyr_xyr_xyr(xyr_VLon,xyr_VLat,xyr_VRad))

    write(6,*)'Checking Divergence'
    do k=1,km
       do j=1,jm
          do i=0,im-1
             if ( abs(xyr_Data(i,j,k)-xyr_Div(i,j,k)) > eps ) then
                write(6,*) i,j,k, xyr_Data(i,j,k), xyr_Div(i,j,k)
                call MessageNotify('E','wq_test_derivative2', &
                     'Derivative error too large.')
             endif
          end do
       end do
    end do

  end subroutine checkresult

end program wq_test_derivative2

